<template>
  <div class="gpa-library__content">
    <rui-panel resize="right" class="gpa-library__list-panel">
      <rui-search-form v-model="searchTerm" />

      <recycle-scroller v-slot="{item}"
                        key-field="id"
                        class="_virtual-scroll-area"
                        :items="families"
                        :item-size="41">
        <rui-list-item :active="item.id === selectedFamilyId"
                       :caption="item.name"
                       :to="{params: {familyId: item.id}}">
          <template #right>
            <rui-button v-if="item.source"
                        icon="external-link"
                        :href="item.source"
                        target="_blank"
                        rel="noopener noreferrer" />
            <rui-button icon="pencil" :title="$t('generic.edit')" @click="$emitBus('edit-family', item)" />
          </template>
        </rui-list-item>
      </recycle-scroller>
    </rui-panel>

    <rui-panel resize="right" class="gpa-library__list-panel">
      <rui-alert v-if="!resources" variant="mute">{{ $t('js.genera.index.no_selected_family') }}</rui-alert>
      <recycle-scroller v-else
                        v-slot="{item}"
                        key-field="id"
                        class="_virtual-scroll-area"
                        :items="resources"
                        :item-size="48">
        <rui-list-item :active="item.id === selectedResourceId"
                       :sub-caption="item.latinName"
                       :image="item.picturePath"
                       :icon="item.generic? 'generic' : null"
                       :to="{params: {resourceId: item.id}}">
          <rui-icon v-if="item.generic" name="generic" /> {{ item.name }}
        </rui-list-item>
      </recycle-scroller>
    </rui-panel>

    <div class="gpa-library__content__resource">
      <rui-alert v-if="!selectedResource" variant="mute">{{ $t('js.genera.index.no_selected_resource') }}</rui-alert>
      <div v-else>
        <gpa-resource-description-area :resource="selectedResource" :show-links="true" />
      </div>
    </div>
  </div>
</template>

<script>
import RuiAlert from '@experiments-labs/rise_ui/src/components/Alert/Alert.vue'
import RuiButton from '@experiments-labs/rise_ui/src/components/Button/Button.vue'
import RuiSearchForm from '@experiments-labs/rise_ui/src/components/Form/SearchForm.vue'
import RuiIcon from '@experiments-labs/rise_ui/src/components/Icon/Icon.vue'
import RuiListItem from '@experiments-labs/rise_ui/src/components/ListItem/ListItem.vue'
import RuiPanel from '@experiments-labs/rise_ui/src/components/Panel/Panel.vue'

import GpaResourceDescriptionArea from './Resources/_Resource.vue'

export default {
  name: 'GpaLibraryByFamily',
  components: { RuiAlert, RuiIcon, RuiButton, RuiListItem, RuiSearchForm, RuiPanel, GpaResourceDescriptionArea },
  data () {
    return {
      order: 'name',
      selectedResourceId: null,
      selectedFamilyId: null,
      searchTerm: '',
      filters: {
        tags: [],
        shelteredSowingMonths: [],
        soilSowingMonths: [],
        harvestingMonths: [],
      },
    }
  },
  computed: {
    resources () {
      if (this.selectedFamily) return this.selectedFamily.resources

      return null
    },
    families () {
      return this.$store.getters.families
        .filter(f => f.name.toLowerCase().includes(this.searchTerm.toLowerCase()))
    },
    selectedResource () { return this.$store.getters.resource(this.selectedResourceId) },
    selectedFamily () { return this.$store.getters.family(this.selectedFamilyId) },
  },
  methods: {
    setIds () {
      const familyId = this.$route.params.familyId
      this.selectedFamilyId = familyId ? parseInt(familyId, 10) : null

      const resourceId = this.$route.params.resourceId
      this.selectedResourceId = resourceId && familyId ? parseInt(resourceId, 10) : null
    },
  },
  created () {
    this.setIds()
  },
  watch: {
    $route () {
      this.setIds()
    },
  },
}
</script>
